module Backend
  module Db
    Clear.enum UserRole, :teacher, :student

    struct UserRole
      # API representation of the enum
      def to_api : Api::Schema::UserRole
        Api::Schema::UserRole.parse(self.to_s)
      end

      # DB representation of the enum
      def self.from_api(role : Api::Schema::UserRole) : self
        role.to_db
      end
    end

    class User
      include Clear::Model
      self.table = :users

      primary_key type: :serial

      column username : String
      column role : UserRole
      column admin : Bool = false
      column skif : Bool

      has_one student : Student?, foreign_key: :user_id
      has_one teacher : Teacher?, foreign_key: :user_id
    end
  end
end
